// ------ polyline.h
#ifndef POLYLINE_H
#define POLYLINE_H

#include <line.h>

namespace GraphicsLibrary  {

template <class T>
class Polyline : public TShape<T>  {
protected:
	std::vector<Point> vertices;
public:
    Polyline(T& t, Point pos, std::vector<Point> pts, Color clr = black) :
			TShape<T>(&t, pos, clr), vertices(pts)
	    {  }
    Polyline(T& t, Point pos, Color clr = black) : 
			TShape<T>(&t, pos, clr)
    	{  }
	void setvertices(const std::vector<Point>& pts)
		{ vertices = pts; }
	void addvertex(Point pt)
		{ vertices.push_back(pt); }
    virtual void draw();
};

template <class T>
void Polyline<T>::draw()
{
	if (vertices.begin() < vertices.end())	{
		Point pt1 = *vertices.begin();
		rotate(pt1);
		Point pt0(position);
		rotate(pt0);
	    std::vector<Point>::iterator iter;
    	for (iter = vertices.begin()+1; iter < vertices.end(); iter++)  {
        	Point pt2 = *iter;
			rotate(pt2);
			Line<T> line(*tp, pt1 + pt0, pt2 + pt0, color);
			line.draw();
   	    	pt1 = pt2;
    	}
	}
}

} // namespace GraphicsLibrary

#endif