// ------ rectangle.h

#ifndef RECTANGLE_H
#define RECTANGLE_H
#include <polygon.h>

namespace GraphicsLibrary  {

template <class T>
class Rectangle : public Polygon<T>  {
	int height, width;
	virtual void drawfilled();
public:
	Rectangle(T& t, Point pos, int ht, int wd, Color clr = black, bool fill = false);
	virtual void draw();
};
template <class T>
Rectangle<T>::Rectangle(T& t, Point pos, int ht, int wd, Color clr, bool fill) :
			Polygon<T>(t, pos, clr, fill), 
			height(ht), width(wd)
{
	addvertex(Point(0,0));
	addvertex(Point(width-1,0));
	addvertex(Point(width-1,height-1));
	addvertex(Point(0,height-1));
}
// ---- redundant function declaration supports specializations
template <class T>
void Rectangle<T>::draw()
{
	Polygon<T>::draw();
}

template <class T>
void Rectangle<T>::drawfilled()
{
	if (rotation != 0)
		Polygon<T>::drawfilled();
	else	{
		Point pt(0,0);
		while (pt.y < height)	{
			while (pt.x < width)	{
				drawpoint(pt);
				pt.x++;
			}
			pt.y++;
		}
	}
}

} // namespace GraphicsLibrary

#endif