#include <tyfc.h>
#include <circle.h>
#include <polygon.h>
#include <rectangle.h>
#include <line.h>
#include <ellipse.h>
//#include <specialize.h>

namespace GL = GraphicsLibrary;

class GApp : public TYFCApp  {
	GL::Circle<TYFCApp>    circle;
	GL::Rectangle<TYFCApp> rectangle;
	GL::Line<TYFCApp>      line;
	GL::Polygon<TYFCApp>   polygon;
	GL::Polygon<TYFCApp>   poly2;
	GL::Ellipse<TYFCApp>   ellipse;
public:
	GApp();
    void Initialize();
};

GApp::GApp() : TYFCApp("Graphics", 400, 350),
				rectangle(*this, GL::Point(-50, -55),  80, 95, blue, true),
				circle   (*this, GL::Point( 50, -15),  120,    yellow, true),
				line     (*this, GL::Point(-110, -100), GL::Point(122, 43), green),
				poly2    (*this, GL::Point(-50,20), red),
				polygon  (*this, GL::Point(-50,20),   magenta, true),
				ellipse  (*this, GL::Point(60,100), 60, 40, black, true)
{
	static GL::Point pts[] = {
		GL::Point(-30,-30),
		GL::Point(-10,-40),
		GL::Point(-30,-30),
		GL::Point(-10,-40),
		GL::Point(50,-35),
		GL::Point(70,-10),
		GL::Point(65,20),
		GL::Point(10,15),
		GL::Point(-25,60),
		GL::Point(-37,20)
	};
	for (int i = 0; i < sizeof(pts) / sizeof(GL::Point); i++)	{
		polygon.addvertex(pts[i]);
		poly2.addvertex(pts[i]);
	}
	rectangle.setrotation(10);
	polygon.setrotation(-20);
	poly2.setrotation(20);
}

void GApp::Initialize()
{
	addshape(circle);
	addshape(rectangle);
	addshape(polygon);
	addshape(poly2);
	addshape(line);
	addshape(ellipse);
}

static GApp app;

