/*
This file and all other related Python Server Pages files are Copyright (c) 1999 Angell
Enterprises, Inc.  All rights reserved.
*/


package com.vmc.psp;

import javax.servlet.*;
import javax.servlet.http.*;
import java.util.Hashtable;
import java.util.Vector;
import java.util.Enumeration;
import org.python.core.*;

public class PyRequest extends PyObject {

	HttpServletRequest m_req;
	PyParams m_pyParams = null;
	PyServerVariables m_pyServerVars = null;
	PyDictionary m_Cookies = null;
  
	public PyRequest( HttpServletRequest req ) {
  	m_req = req;
	}

  //
  // Methods
  //
  public PyServerVariables getServer() {

  	if ( m_pyServerVars == null )
    	m_pyServerVars = new PyServerVariables(m_req);

    return m_pyServerVars;

  } // getServerVars

  public PyDictionary getCookies() {

  	if ( m_Cookies == null )
    	m_Cookies = PSP.makeCookies( m_req.getCookies() );

    return m_Cookies;

  } // getCookies

  public PyParams getParams() {

  	if ( m_pyParams == null )
    	m_pyParams = new PyParams(m_req);

    return m_pyParams;

  } // parms

  public PyObject Cookie( String name, String value ) {
  	return Py.java2py(new Cookie( name, value ));
  }
  public PyObject Cookie( String name ) {
  	return Py.java2py(new Cookie( name, "" ));
  }

  public PyFile getBinarystream()
  	throws java.io.IOException {

    return new PyFile( m_req.getInputStream(),"http_request" );
  } // getBinarystream


} // PyRequest


