/*
This file and all other related Python Server Pages files are Copyright (c) 1999 Angell
Enterprises, Inc.  All rights reserved.
*/


package com.vmc.psp;

import javax.servlet.*;
import javax.servlet.http.*;
import java.util.Vector;
import java.util.Enumeration;
import org.python.core.*;


public class PyServerVariables extends PyObject {

  Vector m_headerNames = new Vector();
	HttpServletRequest m_req;

  PyServerVariables(HttpServletRequest req) {

   	m_req = req;
   	Enumeration e = m_req.getHeaderNames();
		while ( e.hasMoreElements() ) {

			String s = (String)e.nextElement();
       m_headerNames.addElement( new PyString(s) );

    } // while

  }

 	public PyObject get(PyObject key, PyObject default_object) {
		PyObject o = __finditem__(key);
		if (o == null) return default_object;
		else return o;
	}

	public PyObject get(PyObject key) {
		return get(key, Py.None);
	}

	public boolean __nonzero__() throws PyException {
		return m_headerNames.size() != 0;
	}

  public PyString __repr__() throws PyException {

  	Enumeration ek = m_headerNames.elements();
		Enumeration ev = valueVector().elements();
		int n = m_headerNames.size();
		StringBuffer buf = new StringBuffer("{");

		for(int i=0; i<n; i++) {
			buf.append(((PyObject)ek.nextElement()).__repr__().toString());
			buf.append(": ");
			buf.append(((PyObject)ev.nextElement()).__repr__().toString());
			if (i < n-1) buf.append(", ");
		}
		buf.append("}");
		return new PyString(buf.toString());

	}

   public int __len__() {
		return m_headerNames.size();
   }

   public PyObject __finditem__(PyObject key) {

   	int i = findItem( (PyString)key );
		if ( i != -1 ) {

    	String value = m_req.getHeader(
 	    	m_headerNames.elementAt(i).toString() );

      return Py.java2py( value );

		} // if

    return null;
	}

  public boolean has_key(PyObject p0) {
  	return ( findItem( (PyString)p0 ) != -1 );
  }

  public PyList items() {
		Enumeration ek = m_headerNames.elements();
		Enumeration ev = valueVector().elements();
		int n = m_headerNames.size();
		java.util.Vector l = new java.util.Vector(n);

		for(int i=0; i<n; i++)
			l.addElement(new PyTuple(new PyObject[]
				{(PyObject)ek.nextElement(), (PyObject)ev.nextElement()}));
		return new PyList(l);
	}

  public PyList keys() {
  	return new PyList( m_headerNames );
  }

  public PyList values() {
  	return new PyList( valueVector() );
  }

  Vector valueVector() {
   	Vector v = new Vector();
    Enumeration keys = m_headerNames.elements();
    while ( keys.hasMoreElements() )
     	v.addElement( __finditem__(	(PyObject)keys.nextElement() ) );

    return v;
	}

	int findItem( PyString key ) {

		for( int i = 0; i < m_headerNames.size(); i++ ) {

			if ( m_headerNames.elementAt(i).equals(key) )
        	return i;

    } // for

    return -1;

	} // findItem

} // Params

