/*
This file and all other related Python Server Pages files are Copyright (c) 1999 Angell
Enterprises, Inc.  All rights reserved.
*/

package com.vmc.psp;

import javax.servlet.*;
import javax.servlet.http.HttpSession;
import java.util.Vector;
import java.util.Enumeration;
import org.python.core.*;


public class PySession extends PyObject {

	HttpSession m_ses;

  PySession(HttpSession ses) {

   	m_ses = ses;
  }

 	public PyObject get(PyObject key, PyObject default_object) {
		PyObject o = __finditem__(key);
		if (o == null) return default_object;
		else return o;
	}

	public PyObject get(PyObject key) {
		return get(key, Py.None);
	}

	public boolean __nonzero__() throws PyException {
		return m_ses.getValueNames().length != 0;
	}

  public PyString __repr__() throws PyException {

  	String[] names = m_ses.getValueNames();
		Enumeration ev = valueVector().elements();
		int n = names.length;
		StringBuffer buf = new StringBuffer("{");

		for(int i=0; i<n; i++) {
			buf.append(names[n]);
			buf.append(": ");
			buf.append(((PyObject)ev.nextElement()).__repr__().toString());
			if (i < n-1) buf.append(", ");
		}
		buf.append("}");
		return new PyString(buf.toString());

	}

   public int __len__() {
		return m_ses.getValueNames().length;
   }

	public void __setitem__(PyObject key, PyObject value)  {

  	m_ses.putValue( key.toString(), value );
	}

	public void __delitem__(PyObject key) throws PyException {
		m_ses.removeValue( key.toString() );
	}

   public PyObject __finditem__(PyObject key) {

    Object o = m_ses.getValue( key.toString() );
    if ( o == null )
    	return null;
    else
    	return Py.java2py( o );
	}

  public boolean has_key(PyObject p0) {
  	Object o = m_ses.getValue( p0.toString() );
    if ( o == null )
    	return false;
    else
    	return true;
  }

  public PyList items() {

  	String[] names = m_ses.getValueNames();

		int n = names.length;
		java.util.Vector l = new java.util.Vector(n);

		for(int i=0; i<n; i++)
			l.addElement(new PyTuple(new PyObject[]
				{Py.java2py( names[i] ),
        Py.java2py( m_ses.getValue( names[i] )) }));

		return new PyList(l);
	}

  public PyList keys() {

  	String[] names = m_ses.getValueNames();

		int n = names.length;
		java.util.Vector l = new java.util.Vector(n);

		for(int i=0; i<n; i++)
			l.addElement( Py.java2py( names[i] ) );
  	return new PyList( l );
  }

  public PyList values() {
  	return new PyList( valueVector() );
  }

  Vector valueVector() {

  	String[] names = m_ses.getValueNames();
    int n = names.length;
    
   	Vector v = new Vector();
    for(int i=0; i<n; i++)
     	v.addElement( __finditem__(	Py.java2py( names[n] ) ));

    return v;
	}

} // Session

